/* ***********************************************************
 * This file was automatically generated on 2020-05-19.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.26                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures ambient light up to 900lux
	/// </summary>
	public class BrickletAmbientLight : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 21;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Ambient Light Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ILLUMINANCE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ILLUMINANCE_CALLBACK_THRESHOLD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_ILLUMINANCE = 13;

		private const int CALLBACK_ANALOG_VALUE = 14;

		private const int CALLBACK_ILLUMINANCE_REACHED = 15;

		private const int CALLBACK_ANALOG_VALUE_REACHED = 16;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletAmbientLight.SetIlluminanceCallbackPeriod"/>. The parameter is the illuminance of the
		///  ambient light sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletAmbientLight.IlluminanceCallback"/> callback is only triggered if the illuminance has changed
		///  since the last triggering.
		/// </summary>
		public event IlluminanceEventHandler IlluminanceCallback;
		/// <summary>
		/// </summary>
		public delegate void IlluminanceEventHandler(BrickletAmbientLight sender, int illuminance);

		/// <summary>
		/// </summary>
		public event IlluminanceEventHandler Illuminance // for backward compatibility
		{
			add { IlluminanceCallback += value; }
			remove { IlluminanceCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletAmbientLight.SetAnalogValueCallbackPeriod"/>. The parameter is the analog value of the
		///  ambient light sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletAmbientLight.AnalogValueCallback"/> callback is only triggered if the analog value has
		///  changed since the last triggering.
		/// </summary>
		public event AnalogValueEventHandler AnalogValueCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueEventHandler(BrickletAmbientLight sender, int value);

		/// <summary>
		/// </summary>
		public event AnalogValueEventHandler AnalogValue // for backward compatibility
		{
			add { AnalogValueCallback += value; }
			remove { AnalogValueCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletAmbientLight.SetIlluminanceCallbackThreshold"/> is reached.
		///  The parameter is the illuminance of the ambient light sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletAmbientLight.SetDebouncePeriod"/>.
		/// </summary>
		public event IlluminanceReachedEventHandler IlluminanceReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void IlluminanceReachedEventHandler(BrickletAmbientLight sender, int illuminance);

		/// <summary>
		/// </summary>
		public event IlluminanceReachedEventHandler IlluminanceReached // for backward compatibility
		{
			add { IlluminanceReachedCallback += value; }
			remove { IlluminanceReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletAmbientLight.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameter is the analog value of the ambient light sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletAmbientLight.SetDebouncePeriod"/>.
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueReachedEventHandler(BrickletAmbientLight sender, int value);

		/// <summary>
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReached // for backward compatibility
		{
			add { AnalogValueReachedCallback += value; }
			remove { AnalogValueReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletAmbientLight(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_ILLUMINANCE] = new CallbackWrapper(OnIlluminanceCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE] = new CallbackWrapper(OnAnalogValueCallback);
			callbackWrappers[CALLBACK_ILLUMINANCE_REACHED] = new CallbackWrapper(OnIlluminanceReachedCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE_REACHED] = new CallbackWrapper(OnAnalogValueReachedCallback);


			responseExpected[FUNCTION_GET_ILLUMINANCE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ILLUMINANCE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the illuminance of the ambient light sensor.
		///  
		///  If you want to get the illuminance periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletAmbientLight.IlluminanceCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletAmbientLight.SetIlluminanceCallbackPeriod"/>.
		/// </summary>
		public int GetIlluminance()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ILLUMINANCE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the value as read by a 12-bit analog-to-digital converter.
		///  
		///  <note>
		///   The value returned by <see cref="Tinkerforge.BrickletAmbientLight.GetIlluminance"/> is averaged over several samples
		///   to yield less noise, while <see cref="Tinkerforge.BrickletAmbientLight.GetAnalogValue"/> gives back raw
		///   unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletAmbientLight.GetAnalogValue"/> is,
		///   if you need the full resolution of the analog-to-digital converter.
		///  </note>
		///  
		///   Also, the analog-to-digital converter covers three different ranges that are
		///   set dynamically depending on the light intensity. It is impossible to
		///   distinguish between these ranges with the analog value.
		///  
		///  If you want the analog value periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletAmbientLight.AnalogValueCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletAmbientLight.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public int GetAnalogValue()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletAmbientLight.IlluminanceCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletAmbientLight.IlluminanceCallback"/> callback is only triggered if the illuminance has changed
		///  since the last triggering.
		/// </summary>
		public void SetIlluminanceCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletAmbientLight.SetIlluminanceCallbackPeriod"/>.
		/// </summary>
		public long GetIlluminanceCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletAmbientLight.AnalogValueCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletAmbientLight.AnalogValueCallback"/> callback is only triggered if the analog value has
		///  changed since the last triggering.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletAmbientLight.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public long GetAnalogValueCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletAmbientLight.IlluminanceReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the illuminance is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the illuminance is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the illuminance is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the illuminance is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetIlluminanceCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_ILLUMINANCE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletAmbientLight.SetIlluminanceCallbackThreshold"/>.
		/// </summary>
		public void GetIlluminanceCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletAmbientLight.AnalogValueReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the analog value is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the analog value is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the analog value is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the analog value is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletAmbientLight.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletAmbientLight.IlluminanceReachedCallback"/>,
		///  * <see cref="Tinkerforge.BrickletAmbientLight.AnalogValueReachedCallback"/>
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletAmbientLight.SetIlluminanceCallbackThreshold"/>,
		///  * <see cref="Tinkerforge.BrickletAmbientLight.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletAmbientLight.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
		///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnIlluminanceCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int illuminance = LEConverter.UShortFrom(8, response);
			var handler = IlluminanceCallback;

			if (handler != null)
			{
				handler(this, illuminance);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int value = LEConverter.UShortFrom(8, response);
			var handler = AnalogValueCallback;

			if (handler != null)
			{
				handler(this, value);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnIlluminanceReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int illuminance = LEConverter.UShortFrom(8, response);
			var handler = IlluminanceReachedCallback;

			if (handler != null)
			{
				handler(this, illuminance);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int value = LEConverter.UShortFrom(8, response);
			var handler = AnalogValueReachedCallback;

			if (handler != null)
			{
				handler(this, value);
			}
		}
	}
}
